#Incremental Feature Selection
import pandas as pd

#Load data
file_path_full_training_set = 'FS_Data/train_data.csv'
file_path_full_test_set1 = 'FS_Data/validation_0.7.csv'
file_path_full_test_set = 'FS_Data/test_data.csv'

train_data=pd.read_csv(file_path_full_training_set)
test_data=pd.read_csv(file_path_full_test_set)
test_data1=pd.read_csv(file_path_full_test_set1)

# binary label
train_data['attack_class'] = train_data['attack_class'].replace([0], [0])
train_data['attack_class'] = train_data['attack_class'].replace([1], [1])
train_data['attack_class'] = train_data['attack_class'].replace([2], [1])
train_data['attack_class'] = train_data['attack_class'].replace([3], [1])
train_data['attack_class'] = train_data['attack_class'].replace([4], [1])

test_data['attack_class'] = test_data['attack_class'].replace([0], [0])
test_data['attack_class'] = test_data['attack_class'].replace([1], [1])
test_data['attack_class'] = test_data['attack_class'].replace([2], [1])
test_data['attack_class'] = test_data['attack_class'].replace([3], [1])
test_data['attack_class'] = test_data['attack_class'].replace([4], [1])

test_data1['attack_class'] = test_data1['attack_class'].replace([0], [0])
test_data1['attack_class'] = test_data1['attack_class'].replace([1], [1])
test_data1['attack_class'] = test_data1['attack_class'].replace([2], [1])
test_data1['attack_class'] = test_data1['attack_class'].replace([3], [1])
test_data1['attack_class'] = test_data1['attack_class'].replace([4], [1])

drop_cols = train_data.loc[:,[i for i in list(train_data.columns) if i in [
'dst_host_srv_count',
'dst_host_same_srv_rate',
'is_guest_login',
]]]
train_data.drop(drop_cols, axis=1, inplace=True)

drop_cols1 =test_data.loc[:,[i for i in list(test_data.columns) if i in [
'dst_host_srv_count',
'dst_host_same_srv_rate',
'is_guest_login',
]]]
test_data.drop(drop_cols1, axis=1, inplace=True)

# from sklearn.model_selection import train_test_split
# # Divide the dataset into training and validation sets
train_data=pd.concat([train_data,test_data1],axis=0)
# training, testing = train_test_split(train_data,test_size=0.3, random_state=1)
X_train=train_data.drop('attack_class',axis=1)
y_train=train_data['attack_class']
X_test=test_data.drop('attack_class',axis=1)
y_test=test_data['attack_class']

#Incremental Feature Selection（IFS）
def IFS(X_train,y_train,X_test,y_test):
    final_acc = []
    for i in range(1, 32):
        data_X = X_train.iloc[:, :i]
        test_data_X=X_test.iloc[:,:i]
        print(data_X.shape)

        from sklearn.ensemble import RandomForestClassifier
        rnd_clf = RandomForestClassifier(n_estimators=300, random_state=42)
        rnd_clf.fit(data_X, y_train)
        y_pred_rf = rnd_clf.predict(test_data_X)
        acc = rnd_clf.score(test_data_X, y_test)
        print(acc)
        final_acc.append(acc)

    print(final_acc)
    return final_acc

final_acc=IFS(X_train,y_train,X_test,y_test)

import matplotlib.pyplot as plt
list_x=range(1,32)
plt.plot(list_x, final_acc)
plt.xlabel("Number of Features")
plt.ylabel("Accuracy")
plt.show()
plt.savefig("./RF-ACC.png")


