#Calculate the correlation coefficient matrix of the training set
import numpy as np
import pandas as pd
import matplotlib.pyplot as plt
import seaborn as sns

import warnings
warnings.filterwarnings('ignore')

import os
os.environ["CUDA_VISIBLE_DEVICES"]="0"

#Load data
file_path_full_training_set = '../Restructure_data/train_data+_sort.csv'
train_data=pd.read_csv(file_path_full_training_set)

data = train_data.copy()
X_train = data.drop('attack_class', axis = 1)
y_train = data['attack_class']

cols=X_train.columns
cols1=list(X_train.columns)

from sklearn.preprocessing import StandardScaler
stdsc=StandardScaler()
X_train=stdsc.fit_transform(X_train)

cov_mat=np.cov(X_train.T)
# print(cov_mat)
plt.figure(figsize=(50,40))
sns.set(font_scale=3)
hm=sns.heatmap(cov_mat,cbar=True,annot=True,square=True,fmt='.2f',annot_kws={'size':30},cmap='coolwarm',yticklabels=cols,xticklabels=cols)
plt.title('Covariance matrix showing correlation coefficients--KDDTrain+',size=65)
plt.tight_layout()
plt.savefig("./Correlation_Matrix.png")
plt.show()

correlation_matrix=np.tril(cov_mat,-1)
# print(correlation_matrix)

lower_corr_list=[]
list1=[]
for i in range(correlation_matrix.shape[0]):
    for j in range(correlation_matrix.shape[1]):

        if correlation_matrix[i][j]>=0.9:
            feature = []
            feature.append(cols1[i])
            feature.append(cols1[j])

            info = []
            for k in range(len(feature)):
                for v in range(len(cols1)):
                    if feature[k] == cols1[v]:
                        info.append(v)

            if info[0] > info[1]:
                lower_corr_list.append(feature[0])
            else:
                lower_corr_list.append(feature[1])

lower_corr_list=set(lower_corr_list)
lower_corr_list=list(lower_corr_list)
# print(lower_corr_list)

# f = open("../Restructure_data/delete_feature_0.9.txt", "w")
# for line in lower_corr_list:
#     f.write(str(line) + '\n')
# f.close()
















