import numpy as np
import pandas as pd
from keras.distribute.keras_utils_test import Counter
from sklearn.metrics import confusion_matrix
from sklearn import metrics
from sklearn.metrics import precision_score
from sklearn.metrics import recall_score
from sklearn.metrics import f1_score
from sklearn.metrics import classification_report
from sklearn.metrics import accuracy_score
from sklearn.model_selection import StratifiedKFold, train_test_split
import pickle
import numpy
import tensorflow.keras
import tensorflow as tf
from sklearn.preprocessing import Normalizer,MinMaxScaler
from tensorflow.keras.models import Sequential, load_model
from tensorflow.keras.layers import Dense, Dropout, Activation, Embedding, Lambda
from tensorflow.keras.layers import LSTM, SimpleRNN, GRU, Bidirectional, BatchNormalization,Convolution1D,MaxPooling1D, Reshape, GlobalAveragePooling1D
from tensorflow.keras.utils import to_categorical

import warnings

from tensorflow.python.ops.image_ops_impl import ssim
warnings.filterwarnings('ignore')
import os
os.environ["CUDA_VISIBLE_DEVICES"]="0"

def load_data():
    file_path_full_training_set = '../Restructure_data/train_data+_ADASYN.csv'
    file_path_test = '../Restructure_data/test_data+_sort.csv'

    df = pd.read_csv(file_path_full_training_set)
    test_df = pd.read_csv(file_path_test)

    # # 转换为二分类
    # df['attack_class'] = df['attack_class'].replace([0], [0])
    # df['attack_class'] = df['attack_class'].replace([1], [1])
    # df['attack_class'] = df['attack_class'].replace([2], [1])
    # df['attack_class'] = df['attack_class'].replace([3], [1])
    # df['attack_class'] = df['attack_class'].replace([4], [1])
    # #
    # test_df['attack_class'] = test_df['attack_class'].replace([0], [0])
    # test_df['attack_class'] = test_df['attack_class'].replace([1], [1])
    # test_df['attack_class'] = test_df['attack_class'].replace([2], [1])
    # test_df['attack_class'] = test_df['attack_class'].replace([3], [1])
    # test_df['attack_class'] = test_df['attack_class'].replace([4], [1])

    data = df.copy()
    test_data = test_df.copy()

    X_train = data.drop('attack_class', axis=1)
    feature_sort=['protocol_type','service','flag','src_bytes','dst_bytes','same_srv_rate','diff_srv_rate','logged_in','dst_host_srv_count','dst_host_same_srv_rate','dst_host_srv_serror_rate',
'dst_host_diff_srv_rate','dst_host_serror_rate','srv_serror_rate','serror_rate','count','srv_count','dst_host_same_src_port_rate','dst_host_srv_diff_host_rate','dst_host_count','srv_diff_host_rate','dst_host_srv_rerror_rate',
'rerror_rate','srv_rerror_rate','dst_host_rerror_rate','duration','hot','num_compromised','wrong_fragment','num_root','num_access_files','num_file_creations','is_guest_login','num_failed_logins','su_attempted','root_shell',
                  'num_shells','urgent','land','is_host_login','num_outbound_cmds']
    X_trainn = pd.DataFrame()
    for i in range(len(feature_sort)):
        X_trainn = X_trainn.append(X_train[feature_sort[i]])
    X_trainn = pd.DataFrame(X_trainn.values.T, columns=X_trainn.index, index=X_trainn.columns)
    X_test = test_data.drop('attack_class', axis=1)
    y_train = data['attack_class']
    y_test = test_data['attack_class']

    print(X_train.shape)
    return X_trainn, y_train, X_test, y_test

from tensorflow.keras import layers
import tensorflow as tf
from tensorflow import keras
class TransformerEncoder(layers.Layer):
    def __init__(self, embed_dim, dense_dim, num_heads, rate=0.1,bias=False,**kwargs):
        super().__init__(**kwargs)
        self.embed_dim = embed_dim
        self.dense_dim = dense_dim
        self.num_heads = num_heads
        self.attention = layers.MultiHeadAttention(num_heads=num_heads, key_dim=embed_dim)
        self.dense_proj = keras.Sequential(
            [layers.Dense(dense_dim, activation="relu"),layers.Dense(embed_dim),] )
        self.layernorm_1 = layers.LayerNormalization()
        self.layernorm_2 = layers.LayerNormalization()
        self.dropout1 = layers.Dropout(rate)
        self.dropout2 = layers.Dropout(rate)

    def call(self, inputs, mask=None):
        if mask is not None:
            mask = mask[:, tf.newaxis, :]
        attention_output = self.attention(inputs, inputs, attention_mask=mask)
        proj_input = self.layernorm_1(inputs + attention_output)
        proj_output = self.dense_proj(proj_input)
        return self.layernorm_2(proj_input + proj_output)

    def get_config(self):
        config = super().get_config()
        config.update({
            "embed_dim": self.embed_dim,
            "num_heads": self.num_heads,
            "dense_dim": self.dense_dim, })
        return config

class PositionalEmbedding(layers.Layer):
    def __init__(self, sequence_length, input_dim, output_dim, **kwargs):
        super().__init__(**kwargs)
        self.token_embeddings = layers.Embedding(input_dim=input_dim, output_dim=output_dim)
        self.position_embeddings = layers.Embedding(input_dim=sequence_length, output_dim=output_dim)
        self.sequence_length = sequence_length
        self.input_dim = input_dim
        self.output_dim = output_dim

    def call(self, inputs):
        length = tf.shape(inputs)[-1]
        positions = tf.range(start=0, limit=length, delta=1)
        embedded_tokens = self.token_embeddings(inputs)
        embedded_positions = self.position_embeddings(positions)
        return embedded_tokens + embedded_positions

    def compute_mask(self, inputs, mask=None):
        return tf.math.not_equal(inputs, 0)

    def get_config(self):
        config = super().get_config()
        config.update({
            "output_dim": self.output_dim,
            "sequence_length": self.sequence_length,
            "input_dim": self.input_dim, })
        return config

#BIGRU+ATTENTION
from tensorflow.keras.layers import Dense,Input, Dropout, Embedding, Flatten,MaxPooling1D,Conv1D,SimpleRNN,LSTM,GRU,Multiply,GlobalMaxPooling1D
from tensorflow.keras.layers import Bidirectional,Activation,BatchNormalization,GlobalAveragePooling1D,MultiHeadAttention
from tensorflow.keras.models import Sequential,Model

from datetime import datetime
import tensorflow as tf
import matplotlib.pyplot as plt

class timecallback(tf.keras.callbacks.Callback):
    def __init__(self):
        self.times = []
        self.epochs = []
        # use this value as reference to calculate cummulative time taken
        self.timetaken = tf.timestamp()
    def on_epoch_end(self,epoch,logs = {}):
        # self.times.append(tf.timestamp() - self.timetaken)
        t=tf.timestamp() - self.timetaken
        self.times.append(t)
        print('cost time: ',t.numpy())

        self.epochs.append(epoch)

def get_noise(test_X,test_y,model):
    # true label
    test_label = test_y
    # predict probabilities
    numpy_array_of_predicted_probabilities = model.predict(test_X)

    from cleanlab.dataset import overall_label_health_score
    health = overall_label_health_score(test_label, numpy_array_of_predicted_probabilities)
    print(health)

    from cleanlab.filter import find_label_issues
    ordered_label_issues = find_label_issues(  # One line of code!
        labels=test_label,
        pred_probs=numpy_array_of_predicted_probabilities,
        return_indices_ranked_by='self_confidence'  # Orders label issue
    )

    return health,ordered_label_issues

cleaned_data = []
noise_data = []
health_data=[]
kfold = StratifiedKFold(n_splits=10, shuffle=True, random_state=43)
#average accuracy
avg_accuary = []
#average loss
avg_loss = []
def fold_verification(X_train,y_train,model1):
    kfold.get_n_splits(X_train, y_train)
    oos_pred = []
    # pre_in1 = []
    for train_index, test_index in kfold.split(X_train, y_train):
        train_X, test_X = X_train.iloc[train_index], X_train.iloc[test_index]
        train_y, test_y = y_train.iloc[train_index], y_train.iloc[test_index]
        train_X = train_X.to_numpy()
        test_X = test_X.to_numpy()
        test_xx=test_X
        train_y = train_y.to_numpy()
        test_y = test_y.to_numpy()
        train_X = np.reshape(train_X, (train_X.shape[0], train_X.shape[1], -1))
        test_X = np.reshape(test_X, (test_X.shape[0], test_X.shape[1], -1))
        test_y1=test_y
        train_y = tensorflow.keras.utils.to_categorical(train_y, num_classes=5)
        test_y = tensorflow.keras.utils.to_categorical(test_y, num_classes=5)
        train_y = np.reshape(train_y, (train_y.shape[0], -1))
        test_y = np.reshape(test_y, (test_y.shape[0], -1))
        model1.fit(train_X, train_y, epochs=1, batch_size=128, verbose=0, callbacks=[timecallback()])
        score = model1.evaluate(test_X, test_y, verbose=1)
        print("%s: %.2f%%" % (model1.metrics_names[0], score[0] * 100))
        print("%s: %.2f%%" % (model1.metrics_names[1], score[1] * 100))
        avg_loss.append(score[0] * 100)
        avg_accuary.append(score[1] * 100)

        y_true = np.array(test_y1)

        health,order_label_errors=get_noise(test_X,y_true,model=model1)
        health_data.append(health)

        for i in range(len(test_xx)):
            if i not in order_label_errors:
                con_clean=np.hstack([test_xx[i],y_true[i]])
                cleaned_data.append(con_clean)
            else:
                con_noise=np.hstack([test_xx[i],y_true[i]])
                noise_data.append(con_noise)

    print("%.2f%% (+/- %.2f%%)" % (numpy.mean(avg_accuary), numpy.std(avg_accuary)))
    print("%.2f%% (+/- %.2f%%)" % (numpy.mean(avg_loss), numpy.std(avg_loss)))
    return model1

def evaluate(X_test,y_test,model):
    X_test = X_test.to_numpy()
    y_test = y_test.to_numpy()
    y_eval = y_test.copy()

    pred = model.predict(X_test)
    class_x = np.argmax(pred, axis=1)

    pre_in = []
    pre_pred=[]
    for i in range(len(class_x)):
        if (y_eval[i] != class_x[i]):
            pre_in.append(i)
            pre_pred.append(pred[i])

    print("Number of prediction error samples：")
    print(len(pre_in))

    pre_pred1=[]
    for i in range(len(pred)):
        pre_pred1.append(pred[i])

    acc = accuracy_score(y_eval, class_x)
    print('acc:', acc)
    print(classification_report(y_eval, class_x))

    cm = metrics.confusion_matrix(y_eval, class_x)
    print("Confusion Matrix")
    print(cm)

def main():
    X_train,y_train,X_test,y_test=load_data()
    model = Sequential()
    model.add(Dense(256, input_shape=(X_train.shape[1],),activation='relu'))  #
    model.add(Dropout(0.5))
    model.add(Dense(128,activation='relu'))
    model.add(Dropout(0.5))
    model.add(Dense(64,activation='relu'))
    model.add(Dropout(0.5))
    model.add(Dense(5, activation='softmax'))

    adam = tf.keras.optimizers.Adam(lr=0.001, beta_1=0.9, beta_2=0.999, epsilon=1e-08)
    model.compile(loss='categorical_crossentropy', optimizer=adam, metrics=['accuracy'])
    print(model.summary())

    model1=fold_verification(X_train,y_train,model)

    #Save selected noise data
    cleaned_data1=pd.DataFrame(cleaned_data)
    noise_data1=pd.DataFrame(noise_data)
    noise_data1.to_csv('.FS_Data/noise_data.csv', index=False)

    evaluate(X_test, y_test, model1)

if __name__ == '__main__':
    main()


