import math

import numpy as np
import pandas as pd
from keras.distribute.keras_utils_test import Counter
from sklearn.metrics import confusion_matrix
from sklearn import metrics
from sklearn.metrics import precision_score
from sklearn.metrics import recall_score
from sklearn.metrics import f1_score
from sklearn.metrics import classification_report
from sklearn.metrics import accuracy_score
from sklearn.model_selection import StratifiedKFold, train_test_split
import pickle
import numpy
import tensorflow.keras
import tensorflow as tf
from sklearn.preprocessing import Normalizer,MinMaxScaler
from tensorflow.keras.models import Sequential, load_model
from tensorflow.keras.layers import Dense, Dropout, Activation, Embedding, Lambda
from tensorflow.keras.layers import LSTM, SimpleRNN, GRU, Bidirectional, BatchNormalization,Convolution1D,MaxPooling1D, Reshape, GlobalAveragePooling1D
from tensorflow.keras.utils import to_categorical
from tensorflow.keras.layers import Dense,Input, Dropout, Embedding, Flatten,MaxPooling1D,Conv1D,SimpleRNN,LSTM,GRU,Multiply,GlobalMaxPooling1D
from tensorflow.keras.layers import Bidirectional,Activation,BatchNormalization,GlobalAveragePooling1D,MultiHeadAttention
from tensorflow.keras.models import Sequential,Model
import tensorflow as tf
import warnings

from tensorflow.python.ops.image_ops_impl import ssim

warnings.filterwarnings('ignore')

import os
os.environ["CUDA_VISIBLE_DEVICES"]="0"

def load_data():
    file_path_full_training_set = '../Restructure_data/train_data+_ADASYN-21_12.csv'
    file_path_test = '../New_Data/new_test-21_attack-mul.csv'

    df = pd.read_csv(file_path_full_training_set)
    test_df = pd.read_csv(file_path_test)

    data = df.copy()
    test_data = test_df.copy()

    X_train = data.drop('attack_class', axis=1)
    X_test = test_data.drop('attack_class', axis=1)
    y_train = data['attack_class']
    y_test = test_data['attack_class']

    print(X_train.shape)
    return X_train, y_train, X_test, y_test


from keras import backend as K
def my_loss(y_true,y_pred,MAE_loss_weight=0.6,e=0.6,MSE_loss_weight=0.6):
#     # MAE_loss=K.mean(K.abs(y_pred-y_true),axis=-1)
    MSE_loss = K.mean(K.square(y_pred - y_true), axis=-1)
    loss1 = K.binary_crossentropy(y_true, y_pred)
    loss2 = K.binary_crossentropy(K.ones_like(y_pred) / 10, y_pred)
    total_loss=(1-e)*loss1 + e*loss2+MSE_loss
    return total_loss

from tensorflow.keras import layers
import tensorflow as tf
from tensorflow import keras
class TransformerEncoder(layers.Layer):
    def __init__(self, embed_dim, dense_dim, num_heads, rate=0.1,bias=False,**kwargs):
        super().__init__(**kwargs)
        self.embed_dim = embed_dim
        self.dense_dim = dense_dim
        self.num_heads = num_heads
        self.attention = layers.MultiHeadAttention(num_heads=num_heads, key_dim=embed_dim)
        # self.attention = layers.MultiHeadAttention(num_heads=num_heads, key_dim=embed_dim)
        self.dense_proj = keras.Sequential(
            [layers.Dense(dense_dim, activation="relu"),layers.Dense(embed_dim),] )
        self.layernorm_1 = layers.LayerNormalization()
        self.layernorm_2 = layers.LayerNormalization()
        self.dropout1 = layers.Dropout(rate)
        self.dropout2 = layers.Dropout(rate)

    def call(self, inputs, mask=None):
        if mask is not None:
            mask = mask[:, tf.newaxis, :]
        attention_output = self.attention(inputs, inputs, attention_mask=mask)
        proj_input = self.layernorm_1(inputs + attention_output)
        proj_output = self.dense_proj(proj_input)
        return self.layernorm_2(proj_input + proj_output)

    def get_config(self):
        config = super().get_config()
        config.update({
            "embed_dim": self.embed_dim,
            "num_heads": self.num_heads,
            "dense_dim": self.dense_dim, })
        return config

class timecallback(tf.keras.callbacks.Callback):
    def __init__(self):
        self.times = []
        self.epochs = []
        # use this value as reference to calculate cummulative time taken
        self.timetaken = tf.timestamp()
    def on_epoch_end(self,epoch,logs = {}):
        # self.times.append(tf.timestamp() - self.timetaken)
        t=tf.timestamp() - self.timetaken
        self.times.append(t)
        print('cost time: ',t.numpy())

        self.epochs.append(epoch)

kfold = StratifiedKFold(n_splits=10, shuffle=True, random_state=43)
#average accuracy
avg_accuary = []
#average loss
avg_loss = []
def fold_verification(X_train,y_train,model1):
    kfold.get_n_splits(X_train, y_train)
    for train_index, test_index in kfold.split(X_train, y_train):
        train_X, test_X = X_train.iloc[train_index], X_train.iloc[test_index]
        train_y, test_y = y_train.iloc[train_index], y_train.iloc[test_index]
        train_X = train_X.to_numpy()
        test_X = test_X.to_numpy()
        train_y = train_y.to_numpy()
        test_y = test_y.to_numpy()
        train_X = np.reshape(train_X, (train_X.shape[0], train_X.shape[1], -1))
        test_X = np.reshape(test_X, (test_X.shape[0], test_X.shape[1], -1))
        train_y = tensorflow.keras.utils.to_categorical(train_y, num_classes=5)
        test_y = tensorflow.keras.utils.to_categorical(test_y, num_classes=5)
        train_y = np.reshape(train_y, (train_y.shape[0], -1))
        test_y = np.reshape(test_y, (test_y.shape[0], -1))
        model1.fit(train_X, train_y, epochs=1, batch_size=128, verbose=0, callbacks=[timecallback()])
        model1.save('../Weights/BiGRU+Trans_test+_mul.h5')
        score = model1.evaluate(test_X, test_y, verbose=1)
        print("%s: %.2f%%" % (model1.metrics_names[0], score[0] * 100))
        print("%s: %.2f%%" % (model1.metrics_names[1], score[1] * 100))
        avg_loss.append(score[0] * 100)
        avg_accuary.append(score[1] * 100)

    print("%.2f%% (+/- %.2f%%)" % (numpy.mean(avg_accuary), numpy.std(avg_accuary)))
    print("%.2f%% (+/- %.2f%%)" % (numpy.mean(avg_loss), numpy.std(avg_loss)))
    return model1

def evaluate(X_test,y_test,model):
    X_test = X_test.to_numpy()
    y_test = y_test.to_numpy()
    y_eval = y_test.copy()

    pred = model.predict(X_test)
    class_x = np.argmax(pred, axis=1)

    pre_in = []
    pre_pred=[]
    for i in range(len(class_x)):
        if (y_eval[i] != class_x[i]):
            pre_in.append(i)
            pre_pred.append(pred[i])

    acc = accuracy_score(y_eval, class_x)
    print('acc:', acc)
    print(classification_report(y_eval, class_x))

    cm = metrics.confusion_matrix(y_eval, class_x)
    print("Confusion Matrix")
    print(cm)

def main():
    X_train,y_train,X_test,y_test=load_data()
    batch_size = 128
    inputs = Input(name='inputs', shape=[X_train.shape[1], 1], dtype='float64')
    x = Bidirectional(GRU(64, return_sequences=True))(inputs)
    x = Dense(64, activation='relu')(x)
    x = Dropout(0.5)(x)
    x = TransformerEncoder(64, 64, 2)(x)
    x = GlobalAveragePooling1D()(x)
    x = Reshape((64, 1), input_shape=(64,))(x)
    x = Bidirectional(GRU(32))(x)
    x = Dense(32, activation='relu')(x)
    x = Dropout(0.5)(x)
    output = Dense(5, activation='softmax')(x)
    model = Model(inputs=[inputs], outputs=output)
    adam = tf.keras.optimizers.Adam(lr=0.001, beta_1=0.9, beta_2=0.999, epsilon=1e-08)
    model.compile(loss='categorical_crossentropy', optimizer=adam, metrics=['accuracy'])
    print(model.summary())

    model1=fold_verification(X_train,y_train,model)

    evaluate(X_test, y_test, model1)

if __name__ == '__main__':
    main()


